/*	NOTE: this file contains functions that are used in the overlay	*/
// NOTE: firefly_dataReturn['unique_id'] - result data will be written here from the thread
var firefly_dataReturn = new Object();
// NOTE: firefly_expandTree['unique_id'] - path for the view (unique_id)
var firefly_expandTree = new Object();

// var firefly_sidebarMode = false;

/*	NOTE: split the view horizontal or vertical
 *	el - the element to be split
 *	direction - h -> horizontal, v -> vertical
 *
 *	return - null
*/
function firefly_Split(direction,newpath) {
	try {
		// var elId = firefly_getPref('tab','','currentFilebrowser');
		var el = firefly_GetCurrent();//content.document.getElementById(elId);
		if (!el || el.id == 'firefly_sidebar_filebox') {
			return null;
		}
		var parent=el.parentNode;
		var splittedBox=el;
		var oldPath = splittedBox.path;
		if (newpath == undefined) {
			newpath = oldPath;
		}
		var newBox=null;
		var newSplit=null;
		var newFilebox=null;
		if (direction=='h') {
			newBox=document.createElement('hbox');
		} else if (direction=='v') {
			newBox=document.createElement('vbox');
		} else {
			var e = new Object();
			e['message'] = 'Missing or incorrect direction for splitting';
			e['file'] = 'chrome://firefly/content/js/overlay.js';
			e['function'] = 'firefly_Split()';
			firefly_Logger(e,'error');
			return null;
		}
		newBox.setAttribute('flex',1);
		newSplit=document.createElement('splitter');
		newFilebox=document.createElement('firefly_filebox');
		newFilebox.setAttribute('flex',1);

		var firefly_IdNum = firefly_getPref('tab','deserialize','maxIdNum');//parseInt(firefly_getPref('tab','deserialize','maxIdNum'),10);
		firefly_IdNum++;
		firefly_setPref('tab','serialize','maxIdNum',firefly_IdNum);
		newFilebox.setAttribute('id','firefly_filebox_'+firefly_IdNum);
		newFilebox.setAttribute('type',splittedBox.getAttribute('type'));
		newFilebox.setAttribute('provider',splittedBox.getAttribute('provider'));
		newFilebox.setAttribute('path',newpath);
		newFilebox.path = newpath;

		// newFilebox.setAttribute('onfocus',"focus_tasks(this);");
		// newFilebox.setAttribute('onblur','blur_tasks(this);');

		parent.insertBefore(newBox,splittedBox.nextSibling);
		newBox.appendChild(splittedBox);
		newBox.appendChild(newSplit);
		newBox.appendChild(newFilebox);

		splittedBox.path = oldPath;
		// splittedBox.refresh();															// TODO: check if it is neccesarry
		content.document.getElementById('firefly_filebox_'+firefly_IdNum).refresh();	// TODO: check if it is neccesarry
		splittedBox.focused();

		// NOTE: saving info for restoring tabs
		var id1 = splittedBox.id;
		var id2 = content.document.getElementById('firefly_filebox_'+firefly_IdNum).id;
		var fileboxes = firefly_getPref('tab','deserialize','fileboxes');
		// if (fileboxes != '') {
			// fileboxes = deserialize(fileboxes);
		// } else {
		if (fileboxes == '') {
			fileboxes = new Object();
		}
		if (typeof(fileboxes[id1]) == 'undefined') {
			fileboxes[id1]= new Object();
			fileboxes[id1]['matrix'] = '1';
		}
		var secondMatrix = fileboxes[id1]['matrix'];
		fileboxes[id1]['matrix'] += direction + ',1';

		fileboxes[id1]['path'] = newpath;
		fileboxes[id1]['type'] = splittedBox.getAttribute('type');
		fileboxes[id1]['provider'] = splittedBox.getAttribute('provider');


		if (typeof(fileboxes[id2]) == 'undefined') {
			fileboxes[id2]= new Object();
			fileboxes[id2]['matrix'] = secondMatrix;
		}
		if (fileboxes[id2]['matrix'] == undefined) {
			fileboxes[id2]['matrix'] = secondMatrix;
		}
		fileboxes[id2]['matrix'] += direction + ',2';

		fileboxes[id2]['path'] = newpath;
		fileboxes[id2]['type'] = splittedBox.getAttribute('type');
		fileboxes[id2]['provider'] = splittedBox.getAttribute('provider');


		// alert(serialize(fileboxes));
		firefly_setPref('tab','serialize','fileboxes',fileboxes);
	} catch (e) {
		firefly_Logger(e,'error');
	}
	return null;
}


/*	NOTE: closing an open slit
 *	return - null
*/
function firefly_CloseSplit() {
	try {
		var el = firefly_GetCurrent();
		if (!el || el.id == 'firefly_sidebar_filebox') {
			return null;
		}
		var parent=el.parentNode;
		var toRemove=el;
		var removeId = el.id;
		var parentParent=parent.parentNode;
		if (parent.id == 'mainBox') {
			return null;
		}
		if (toRemove.previousSibling != null) {
			parent.removeChild(toRemove.previousSibling);
			var toStay = toRemove.previousSibling;
			var path = toStay.path;
			parentParent.insertBefore(toRemove.previousSibling,parent.nextSibling);
		} else if (toRemove.nextSibling != null) {
			parent.removeChild(toRemove.nextSibling);
			var toStay = toRemove.nextSibling;
			var path = toStay.path;
			parentParent.insertBefore(toRemove.nextSibling,parent.nextSibling);
		}
		parent.removeChild(toRemove);
		parentParent.removeChild(parent);
		firefly_setPref('tab','serialize','currentFilebrowser',toStay.id);
		toStay.path = path;
		toStay.focus();

		// NOTE: removing info for the removed filebox from fileboxes in the tab
		var fileboxes = firefly_getPref('tab','deserialize','fileboxes');
		if (fileboxes != '') {
			// fileboxes = deserialize(fileboxes);

			// firefly_Logger(fileboxes,'debug');
			var oldMatrix = fileboxes[removeId]['matrix'];
			delete fileboxes[removeId];

			// firefly_Logger(fileboxes,'debug');

			var removeStr = oldMatrix.substr(oldMatrix.length - 4,2);
			var prefix = oldMatrix.substring(0,oldMatrix.length - 5);
			for (key in fileboxes) {
				if (fileboxes[key]['matrix'].indexOf(prefix) == 0 && fileboxes[key]['matrix'].substr(prefix.length + 1,2) == removeStr) {
					fileboxes[key]['matrix'] = prefix + ',1' + fileboxes[key]['matrix'].substr(prefix.length+5);
				}
			}
			// firefly_Logger(fileboxes,'debug');
			firefly_setPref('tab','serialize','fileboxes',fileboxes);
		}
	} catch (e) {
		firefly_Logger(e,'error');
	}
	return null;
}


/*	NOTE: recursive function that gets all children and subchildren of an object and sets them a display property
 *	USED: firefly_FullScreen()
 *	return - null
*/
function firefly_SetAll(object,display) {
	try {
		for (var i = 0;i< object.childNodes.length;i++) {
			if (object.childNodes[i].childNodes.length > 0) {
				// firefly_Logger(object.childNodes[i].childNodes.length,'debug');
				firefly_SetAll(object.childNodes[i],display)
			}
			object.childNodes[i].style.display = display;
		}
	} catch (e) {
		firefly_Logger(e,'error');
	}
	return null;
}


/*	NOTE: toggling fullscreen on and off
 *	return - null
*/
function firefly_FullScreen() {
	try {
		var isFullScreen = firefly_getPref('tab','deserialize','fullScreen');
		var main = content.document.getElementById('mainBox');
		if (isFullScreen == true) {
			firefly_SetAll(main,'')
			document.getElementById('firefly_Fullscreen').setAttribute('state','off');
			firefly_setPref('tab','serialize','fullScreen',false);
		} else {
			var current = firefly_GetCurrent();
			firefly_SetAll(main,'none')
			current.style.display = '';
			while (current.parentNode.id != 'mainBox') {
				current = current.parentNode;
				current.style.display = '';
			}
			document.getElementById('firefly_Fullscreen').setAttribute('state','on');
			firefly_setPref('tab','serialize','fullScreen',true);
		}
	} catch (e) {
		firefly_Logger(e,'error');
	}
	return null;
}


/*	NOTE: when opening the view menu get the current filebox type and check the correct menu
 *	return - null
*/
function firefly_RefreshMenu(object) {
	try {
		var currentType = firefly_GetCurrent().getAttribute('type');
		for (var i=0;i<object.childNodes.length;i++) {
			if (object.childNodes[i].getAttribute('value') == currentType) {
				object.childNodes[i].setAttribute('checked',true);
			} else {
				object.childNodes[i].setAttribute('checked',false);
			}
		}
	} catch (e) {
		firefly_Logger(e,'error');
	}
	return null;
}


/*	NOTE: using the current XBL's method back
 *	return - null
*/
function firefly_back() {
	try {
		firefly_GetCurrent().back();
	} catch (e) {
		firefly_Logger(e,'error');
	}
	return null;
}


/*	NOTE: using current XBL's method to build the back menu
 *	return - null
*/
function firefly_BuildBack(object) {
	try {
		firefly_GetCurrent().buildBack(object);
	} catch (e) {
		firefly_Logger(e,'error');
	}
	return null;
}


/*	NOTE: using the current XBL's method forward
 *	return - null
*/
function firefly_forward() {
	try {
		firefly_GetCurrent().forward();
	} catch (e) {
		firefly_Logger(e,'error');
	}
	return null;
}


/*	NOTE: using current XBL's method to build the forward menu
 *	return - null
*/
function firefly_BuildForward(object) {
	try {
		firefly_GetCurrent().buildForward(object);
	} catch (e) {
		firefly_Logger(e,'error');
	}
	return null;
}


/*	NOTE: using the current XBL's method up
 *	return - null
*/
function firefly_up() {
	try {
		firefly_GetCurrent().up();
	} catch (e) {
		firefly_Logger(e,'error');
	}
	return null;
}


/*	NOTE: using current XBL's method to build the up menu
 *	return - null
*/
function firefly_BuildUp(object) {
	try {
		firefly_GetCurrent().buildUp(object);
	} catch (e) {
		firefly_Logger(e,'error');
	}
	return null;
}


/*	NOTE: using current XBL's method refresh
 *	return - null
*/
function firefly_refresh() {
	try {
		firefly_GetCurrent().refresh();
	} catch (e) {
		firefly_Logger(e,'error');
	}
	return null;
}


/*	NOTE: using current XBL's method to build the filter menu
 *	return - null
*/
function firefly_BuildFilters(object) {
	try {
		firefly_GetCurrent().buildFilters(object);
	} catch (e) {
		firefly_Logger(e,'error');
	}
	return null;
}


/*	NOTE: display the preferences dialog
 *	return - null
*/
function firefly_ShowPrefs() {
	try {
		window.openDialog('chrome://firefly/content/options.xul',"firefly_options","chrome,titlebar,toolbar,centerscreen,modal,resizable=yes");
	} catch (e) {
		firefly_Logger(e,'error');
	}
	return null;
}


/*	NOTE: display the help
 *	return - null
*/
function firefly_ShowHelp() {
	try {
		window.openDialog('chrome://firefly/content/options.xul',"firefly_options","chrome,titlebar,toolbar,centerscreen,modal,resizable=yes", 'help');
		// firefly_OpenTab('help');
	} catch (e) {
		firefly_Logger(e,'error');
	}
	return null;
}


/*	NOTE: add linked split
 *	return - null
*/
function firefly_LinkedAdd() {
	try {
		var linkedArr = firefly_getPref('tab','deserialize','linked');
		if (linkedArr == '') {
			linkedArr = new Array();
		}

		var newLinked = firefly_getPref('tab','deserialize','currentFilebrowser');
		if (firefly_inArray(linkedArr,newLinked) === false) {
			linkedArr.push(newLinked);
			firefly_setPref('tab','serialize','linked',linkedArr);

			var linkedObj = firefly_getPref('tab','deserialize','linkedPaths');
			if (linkedObj == null || linkedObj == '') {
				linkedObj = new Object();
			}
			linkedObj[newLinked] = firefly_GetCurrent().path;
			firefly_setPref('tab','serialize','linkedPaths',linkedObj);
		}
	} catch(e) {
		firefly_Logger(e,'error');
	}
	return null;
}


/*	NOTE: remove linked split
 *	return - null
*/
function firefly_LinkedRemove() {
	try {
		var linkedArr = firefly_getPref('tab','deserialize','linked');
		if (linkedArr == '') {
			linkedArr = new Array();
		}
		var currentLinked = firefly_getPref('tab','deserialize','currentFilebrowser');
		var id = firefly_inArray(linkedArr,currentLinked);
		if (id !== false) {
			linkedArr.splice(id,1);
			firefly_setPref('tab','serialize','linked',linkedArr);

			var linkedObj = firefly_getPref('tab','deserialize','linkedPaths');
			if (linkedObj == null || linkedObj == '') {
				linkedObj = new Object();
			}
			delete linkedObj[newLinked];
			firefly_setPref('tab','serialize','linkedPaths',linkedObj);
		}
	} catch(e) {
		firefly_Logger(e,'error');
	}
	return null;
}


/*	NOTE: fill the linked menu with the elements that are linked
 *	return - null
*/
function firefly_FillLinked() {
	try {
		var linked = document.getElementById('firefly_LinkedMenu');
		var separator = document.getElementById('firefly_SeparatorLinked');
		var next = null;
		while (next = separator.nextSibling){
			linked.removeChild(next);
		}
		var linkedArr = firefly_getPref('tab','deserialize','linked');
		if (linkedArr == '') {
			linkedArr = new Array();
		}

		var linkedObj = firefly_getPref('tab','deserialize','linkedPaths');
		if (linkedObj == null || linkedObj == '') {
			linkedObj = new Object();
		}

		var newEl = null;
		for (var i = 0;i< linkedArr.length;i++) {
			newEl = document.createElement('menuitem');
			newEl.setAttribute('boxID',linkedArr[i]);
			// newEl.setAttribute('label',linkedArr[i]+':'+firefly_GetCurrent(linkedArr[i]).path);
			newEl.setAttribute('label',linkedObj[linkedArr[i]]);
			newEl.setAttribute('onmouseover','content.document.getElementById("'+linkedArr[i]+'").style.border="1px solid red"');
			newEl.setAttribute('onmouseout','content.document.getElementById("'+linkedArr[i]+'").style.border="none"');
			linked.appendChild(newEl);
		}
	} catch(e) {
		firefly_Logger(e,'error');
	}

	return null;
}


/*	NOTE: filter the content of the current view
 *
*/
function firefly_doFilter(filter, event) {
	try {
		if (event.keyCode == 37 || event.keyCode == 38 || event.keyCode == 39 || event.keyCode == 40) {
			return;
		}
		if (event.keyCode == 27) {
			document.getElementById('firefly_PredefinedFilters').hidePopup();
		}
		var filterWitRegEx = firefly_getPref('pref', 'bool', 'extensions.firefly.filterWitRegEx');
		if (filterWitRegEx === false) {
			filter = filter.replace(/\*/g,'.*');
			filter = filter.replace(/\?/g,'.?');
		}
		firefly_GetCurrent().filter = filter;
		firefly_GetCurrent().buildFromFiles();
	} catch (e) {
		firefly_Logger(e,'error');
	}
}


/*	NOTE: mass enable/disable buttons from firefly toolbar
 *	on - array with IDs to enable
*/
function firefly_OnOffBtns(on) {
	try {
		// array with all elements
		var off = new Array();
		off = [ 'firefly_cmdBack', 'firefly_cmdForward', 'firefly_cmdUpDir', 'firefly_cmdRefresh',
				'firefly_cmdCut','firefly_cmdCopy', 'firefly_cmdPaste', 'firefly_cmdDelete',
				'firefly_View', 'firefly_Filter'];
		// first disable all elements
		for (var i = 0;i< off.length;i++) {
			document.getElementById(off[i]).setAttribute('disabled', 'true');
		}
		// then enable the selected ones
		for (var i = 0;i< on.length;i++) {
			document.getElementById(on[i]).setAttribute('disabled', 'false');
		}
	} catch (e) {
		firefly_Logger(e,'error');
	}
}


/*	NOTE: enable/disable specific button from firefly toolbar
 *	on - ID of button
 *	action - on/off
*/
function firefly_OnOffBtn(on, action) {
	try {
		if (action == 'on') {
			var disabled = 'false';
		} else {
			var disabled = 'true';
		}
		document.getElementById(on).setAttribute('disabled', disabled);
	} catch (e) {
		firefly_Logger(e,'error');
	}
}


/*	NOTE: show/hide firefly toolbar
*/
function firefly_toggleToolbar() {
    var toolbar = document.getElementById("firefly_Toolbar");
    toolbar.collapsed = !toolbar.collapsed;
    document.persist("firefly_Toolbar", "collapsed");
}

var fileTypeSettings = new Object();
var firefly_mainNodes = new Object();


// ------------------------------------------------

// NOTE: my XPCOM example
// function sayHello() {
// 	Components
// 		.classes['@fireflyfilemanager.org/background;1']
// 		.getService(Components.interfaces.nsIFireflyFilemanager)
// 		.sayHello();
// }
// sayHello();