function loadDialog() {
	sizeToContent();
	loadList();
	loadAppearance();
}
function loadAppearance() {
	var image = firefly_getPref('pref','char','extensions.firefly.startPageImage');
	document.getElementById('firefly_startPageBackgroundImage').value = image;
	
	var background = firefly_getPref('pref','char','extensions.firefly.startPageBackground');
	document.getElementById('firefly_startPageBackgroundColor').color = background;
	
	var bottomBack = firefly_getPref('pref','char','extensions.firefly.startPageBottomColor');
	document.getElementById('firefly_startPageBottomBackgroundColor').color = bottomBack;
	
	var fontColor = firefly_getPref('pref','char','extensions.firefly.startPageFontColor');
	document.getElementById('firefly_startPageFontColor').color = fontColor;
	
	var fontHoverColor = firefly_getPref('pref','char','extensions.firefly.startPageFontHoverColor');
	document.getElementById('firefly_startPageFontHoverColor').color = fontHoverColor;
}
function loadList() {
	var tree = firefly_getPref('pref','complex','extensions.firefly.tree');
	tree = deserialize(tree);
	var treeList = document.getElementById('treeList');
	for (var i = 0; i < tree.length;i++) {
		var newList = document.createElement('listitem');
		if (tree[i].alias != '') {
			var alias = ' (' + tree[i].alias + ')';
		} else {
			var alias = '';
		}
		newList.setAttribute('label',tree[i].path + alias);
		newList['alias'] = tree[i].alias;
		newList['type'] = tree[i].type;
		newList['path'] = tree[i].path;
		
		newList.setAttribute('onclick', 'loadTreeItem(this);');
		// newList.setAttribute('onkeypress', 'removeItem(event,this);');
		
		treeList.appendChild(newList);
	}
}
function loadTreeItem(el) {
	document.getElementById('updateButton').disabled = false;
	document.getElementById('removeButton').disabled = false;
	document.getElementById('aliasBox').value = el.alias;
	document.getElementById('pathBox').value = el.path;
	document.getElementById('typeBox').value = el.type;
}

function removeItem(ev,el) {
	alert(ev.toSource());
}

function browseFor() {
	var nsIFilePicker = Components.interfaces.nsIFilePicker;
	var fp = Components.classes["@mozilla.org/filepicker;1"].createInstance(nsIFilePicker);
	fp.init(window, firefly_getPref('locale','chrome://firefly/locale/startPageSettings.properties','firefly_chooseFileOrFolder'), nsIFilePicker.modeGetFolder);
	var res = fp.show();
	if (res == nsIFilePicker.returnOK){
		var thefile = fp.file;
		document.getElementById('pathBox').value=thefile.path;
	}
}
function browseForImage() {
	var nsIFilePicker = Components.interfaces.nsIFilePicker;
	var fp = Components.classes["@mozilla.org/filepicker;1"].createInstance(nsIFilePicker);
	fp.init(window,  firefly_getPref('locale','chrome://firefly/locale/startPageSettings.properties','firefly_chooseBackgroundImage'), nsIFilePicker.modeOpen);
	fp.appendFilters(nsIFilePicker.filterImages);
	var res = fp.show();
	if (res == nsIFilePicker.returnOK){
		var thefile = fp.file;
		document.getElementById('firefly_startPageBackgroundImage').value=thefile.path;
	}
}
function move(direction,dialog) {
	var listbox = document.getElementById('treeList');
	var selected = listbox.selectedIndex;
	if (selected != -1) {
		var selectedItem = listbox.getItemAtIndex(selected);
	} else {
		selected = 0;
		var selectedItem = listbox.getItemAtIndex(selected);
		listbox.selectItem(selectedItem);
	}
	if (direction == 'up') {
		if (selected > 0) {
			var movedEl = listbox.insertItemAt(selected - 1,selectedItem.label,selectedItem.value);
			movedEl['path'] = selectedItem['path'];
			movedEl['alias'] = selectedItem['alias'];
			movedEl['type'] = selectedItem['type'];
			movedEl.setAttribute('onclick','loadTreeItem(this);');
			
			listbox.removeItemAt(selected + 1);
			listbox.selectItem(movedEl);
		}
	} else if (direction == 'down') {
		if (selected < listbox.getRowCount()) {
			selectedItem = listbox.getItemAtIndex(selected+1);
			var movedEl = listbox.insertItemAt(selected,selectedItem.label,selectedItem.value);
			movedEl['path'] = selectedItem['path'];
			movedEl['alias'] = selectedItem['alias'];
			movedEl['type'] = selectedItem['type'];
			movedEl.setAttribute('onclick','loadTreeItem(this);');
			
			listbox.removeItemAt(selected + 2);
		}
	}
}

function doAdd() {
	if (document.getElementById('pathBox').value != '') {
		var listbox = document.getElementById('treeList');
		var newEl = document.createElement('listitem');
		if (document.getElementById('aliasBox').value != '') {
			var alias = ' (' + document.getElementById('aliasBox').value + ')';
		} else {
			var alias = '';
		}
		newEl.setAttribute('label',document.getElementById('pathBox').value + alias);
		newEl.setAttribute('onclick','loadTreeItem(this);');
		newEl['path'] = document.getElementById('pathBox').value;
		newEl['alias'] = document.getElementById('aliasBox').value;
		newEl['type'] = document.getElementById('typeBox').value;
		
		listbox.appendChild(newEl);
	}
}

function doUpdate() {
	if (document.getElementById('pathBox').value != '') {
		var listbox = document.getElementById('treeList');
		var listitem = listbox.getItemAtIndex(listbox.selectedIndex);
		
		if (document.getElementById('aliasBox').value != '') {
			var alias = ' (' + document.getElementById('aliasBox').value + ')';
		} else {
			var alias = '';
		}
		listitem.setAttribute('label',document.getElementById('pathBox').value + alias);
		listitem['path'] = document.getElementById('pathBox').value;
		listitem['alias'] = document.getElementById('aliasBox').value;
		listitem['type'] = document.getElementById('typeBox').value;
	}
}
function doRemove() {
	var listbox = document.getElementById('treeList');
	// var listitem = listbox.getItemAtIndex(listbox.selectedIndex);
	listbox.removeItemAt(listbox.selectedIndex);
	listbox.selectItem(listbox.getItemAtIndex(0));
}

function doOK() {
	var listbox = document.getElementById('treeList');
	var tree = new Array();
	for (var i = 0; i < listbox. getRowCount();i++) {
		var listitem = listbox.getItemAtIndex(i);
		tree[i] = new Object();
		tree[i]['path'] = listitem['path'];
		tree[i]['alias'] = listitem['alias'];
		tree[i]['type'] = listitem['type'];
	}
	firefly_setPref('pref','complex','extensions.firefly.tree',serialize(tree));
	
	
	
	var image = document.getElementById('firefly_startPageBackgroundImage').value
	var background = document.getElementById('firefly_startPageBackgroundColor').color
	var bottomBack = document.getElementById('firefly_startPageBottomBackgroundColor').color
	var fontColor = document.getElementById('firefly_startPageFontColor').color
	var fontHoverColor = document.getElementById('firefly_startPageFontHoverColor').color
	
	firefly_setPref('pref','char','extensions.firefly.startPageImage',image);
	firefly_setPref('pref','char','extensions.firefly.startPageBackground',background);
	firefly_setPref('pref','char','extensions.firefly.startPageBottomColor',bottomBack);
	firefly_setPref('pref','char','extensions.firefly.startPageFontColor',fontColor);
	firefly_setPref('pref','char','extensions.firefly.startPageFontHoverColor',fontHoverColor);
	
	return true;
}
function doCancel() {
	return true;
}
