/*	NOTE: build tree - build initial tree
 *
*/
function firefly_buildTree() {
	try {
		var treeContent = document.getElementById('firefly_treeContent');
		var tree = firefly_getPref('pref','complex','extensions.firefly.tree');
		tree = deserialize(tree);
		for (var k in tree) {
			// alert(tree[k].toSource());
			var freeSpace = '';
			var newRoot = document.createElement('hbox');
			newRoot['path'] = tree[k].path;
			newRoot.setAttribute('expanded', 'false');
			newRoot.setAttribute('onclick', 'firefly_openFromTree(this)');

			var newExpander = document.createElement('label');
			newExpander.setAttribute('value', '+');
			newExpander.setAttribute('class', 'treeExpander');
			newExpander.setAttribute('onclick', 'firefly_expandTree(this.parentNode,event);');
			newRoot.appendChild(newExpander);

			var newImage = document.createElement('image');
			newImage.setAttribute('class', 'treeIcon');
			switch(tree[k].type) {
				case 'floppy':
					newImage.setAttribute('src', 'chrome://firefly/skin/img/16/3floppy_unmount.png');
					break;
				case 'cdrom':
					newImage.setAttribute('src', 'chrome://firefly/skin/img/16/cdrom_unmount.png');
					break;
				case 'folder':
					newImage.setAttribute('src', 'chrome://firefly/skin/img/16/folder.png');
					break;
				case 'drive':
					var mb = firefly_getPref('locale','chrome://firefly/locale/start.properties','mb')
					var freeSize = firefly_getPref('locale','chrome://firefly/locale/start.properties','freeSize')
					var aFile = firefly_GetFile(tree[k].path);
					var space = Math.round(100*(aFile.diskSpaceAvailable/1024/1024))/100;
					freeSpace = freeSize + ' ' + space + ' ' + mb;
					newImage.setAttribute('tooltiptext', freeSpace);

					newImage.setAttribute('src', 'chrome://firefly/skin/img/16/hdd_unmount.png');
					break;
				default:
					newImage.setAttribute('src', 'chrome://firefly/skin/img/16/kblackbox.png');
					break;
			}
			newRoot.appendChild(newImage);

			var newName = document.createElement('label');
			var name = '';
			if (tree[k].alias == '' || tree[k].alias == undefined) {
				name = tree[k].path;
			} else {
				name = tree[k].alias + ' [' + tree[k].path + ']';
			}
			newName.setAttribute('value',name);
			if (freeSpace != '') {
				newName.setAttribute('tooltiptext',freeSpace);
			}
			newName.setAttribute('class','treeLabel');
			newRoot.appendChild(newName);

			treeContent.appendChild(newRoot);
		}
	} catch (e) {
		firefly_Logger(e,'error');
	}
}


/*	NOTE: build subtree when an expander is clicked
 *
*/
function firefly_createSubtree(el) {
	try {
		// alert(el['path']);
		var newSubtree = document.createElement('vbox');
		newSubtree.setAttribute('class', 'firefly_subtree');

		var newFile = new firefly_file_provider(el['path'],firefly_getPref('pref','bool','extensions.firefly.hidden_files'));
		newFile.dot_files_as_hidden = firefly_getPref('pref','bool','extensions.firefly.dot_files_as_hidden')
		var [folderDirs,] = newFile.getFolderEntries(false);

		for (var k in folderDirs) {
			// dump(folderDirs[k].toSource() + '\r\n');
			var newRoot = document.createElement('hbox');
			newRoot.setAttribute('expanded', 'false');
			newRoot.setAttribute('onclick', 'firefly_openFromTree(this)');
			newRoot['path'] = folderDirs[k].path;
			var newExpander = document.createElement('label');
			// dump(folderDirs[k].path);
			// dump('\r\n');
			// try {
				var hasChildren = folderDirs[k].hasChildren();
			// } catch(e) {
				// var hasChildren = false;
			// }
			if (hasChildren) {
				newExpander.setAttribute('value', '+');
				newExpander.setAttribute('class', 'treeExpander');
				newExpander.setAttribute('onclick', 'firefly_expandTree(this.parentNode,event);');
			} else {
				newExpander.setAttribute('value', ' ');
				newExpander.setAttribute('class', 'treeExpander');
				// newExpander.setAttribute('expanded', 'false');
			}
			newRoot.appendChild(newExpander);

			var newImage = document.createElement('image');
			newImage.setAttribute('class', 'treeIcon');
			newImage.setAttribute('src', folderDirs[k].getIcon());
			newRoot.appendChild(newImage);

			var newName = document.createElement('label');
			var name = folderDirs[k].getFile().leafName;
			newName.setAttribute('value',name);
			newName.setAttribute('class','treeLabel');
			newRoot.appendChild(newName);

			newSubtree.appendChild(newRoot);
		}

		el.parentNode.insertBefore(newSubtree, el.nextSibling);
	} catch (e) {
		firefly_Logger(e,'error');
	}
}


/*	NOTE: create subtree or delete current subtree
 *	el - element from which the path will be taken
 *	event - to stop the main firefly window from changing when expanding the tree
*/
function firefly_expandTree(el, event) {
	try {
		if (el.getAttribute('expanded') == 'false') {
			firefly_createSubtree(el);
			if (el.childNodes[0].value != ' ') {
				el.childNodes[0].value = '-';
			}
			el.setAttribute('expanded', 'true');
		} else {
			firefly_EraseContent(el.nextSibling);
			if (el.childNodes[0].value != ' ') {
				el.childNodes[0].value = '+';
			}
			el.setAttribute('expanded', 'false');
		}
		if (event != undefined) {
			event.stopPropagation();
		}
		return false;
	} catch (e) {
		firefly_Logger(e,'error');
	}
}


/*	NOTE: expand the tree only by the given path
 *	path - the path to search for
 *	treeContent - the element(vbox) containing the tree elements(hbox)
*/
/*function firefly_expandTreeByPath(path) {
	try {
		var treeContent = document.getElementById('firefly_treeContent');
		var stop = false;
		var returnEl = null;
		do {
			for (var i = 0;i< treeContent.childNodes.length;i++) {
				if (path.indexOf(treeContent.childNodes[i]['path']) == 0) {
					if (treeContent.childNodes[i].getAttribute('expanded') == 'false') {
						firefly_expandTree(treeContent.childNodes[i]);
					}
					if (treeContent.childNodes[i]['path'] == path) {
						stop = true;
						returnEl = treeContent.childNodes[i];
					}
					if (treeContent.childNodes[i].nextSibling.childNodes.length == 0) {
						firefly_expandTree(treeContent.childNodes[i]);
						continue;
					}
					treeContent = treeContent.childNodes[i].nextSibling;
					break;
				}
			}
		} while (stop == false);
		return returnEl;
	} catch (e) {
		firefly_Logger(e,'error');
	}
}*/
function firefly_expandTreeByPath(path, treeContent) {
	try {
		if (treeContent == undefined) {
			treeContent = document.getElementById('firefly_treeContent');
		}
		for (var i = 0;i< treeContent.childNodes.length;i++) {
			var checkPath = treeContent.childNodes[i]['path'];
			if (checkPath == undefined) {
				continue;
			}
			if (path.toLowerCase().indexOf(treeContent.childNodes[i]['path'].toLowerCase()) == 0) {
				if (treeContent.childNodes[i].getAttribute('expanded') == 'false') {
					firefly_expandTree(treeContent.childNodes[i]);
				}
				if (treeContent.childNodes[i]['path'] == path) {
					return true;
				}
				var found = firefly_expandTreeByPath(path, treeContent.childNodes[i].nextSibling);
				if (found) {
					return true;
				} else {
					firefly_expandTree(treeContent.childNodes[i]);
				}
			}
		}
	} catch (e) {
		firefly_Logger(e,'error');
	}
	return false;
}


/*	NOTE: open selected folder in the main window
 *
*/
function firefly_openFromTree(el) {
	try {
		// dump(el['path'] + '\r\n');
		var current = firefly_GetWindow().firefly_GetCurrent();
		if (current != null && current !== false) {
			current.path = el['path'];
			// current.refresh();
		} else {
			firefly_GetWindow().firefly_OpenTab(el['path'],false);
		}
	} catch (e) {
		firefly_Logger(e,'error');
	}
}


/*	NOTE: build the tree and expand it
 *
*/
function firefly_rebuildTree() {
	try {
		firefly_EraseContent(document.getElementById('firefly_treeContent'));
		firefly_buildTree();

		// NOTE: get the array of all open folders and expand the tree according to that
		var expandArr = firefly_GetWindow().firefly_expandTree;
		if (expandArr == undefined) {
			expandArr = new Object();
		}
		for (var k in expandArr) {
			firefly_expandTreeByPath(expandArr[k]);
		}
		// firefly_expandTreeByPath('C:\\Users');
	} catch (e) {
		firefly_Logger(e,'error');
	}
}


/*	NOTE: show/hide tree files - to replace the main view if wanted
 *
*/
function firefly_showHideTreeFiles() {
	try {
		var fileViewActive = document.getElementById('firefly_Folders').getAttribute('fileViewActive');
		if (fileViewActive == 'false') {
			document.getElementById('firefly_treeFiles').style.display = '';

			var tree = firefly_getPref('pref','complex','extensions.firefly.tree');
			tree = deserialize(tree);
			var startPath = '';
			for (var k in tree) {
				startPath = tree[k].path;
				break;
			}

			var newFilebox = document.createElement('firefly_filebox');
			newFilebox.id = 'firefly_sidebar_filebox';
			firefly_setPref('tab','serialize','currentFilebrowser','firefly_sidebar_filebox');
			newFilebox.setAttribute('flex',1);
			newFilebox.setAttribute('style', 'min-height: 300px;');
			// newFilebox.setAttribute('type', 'details');
			newFilebox.setAttribute('type', firefly_getPref('pref', 'char', 'extensions.firefly.defaultView'));
			newFilebox.setAttribute('provider', 'file');
			newFilebox.setAttribute('path', startPath);
			document.getElementById('firefly_treeFiles').appendChild(newFilebox);

			document.getElementById('firefly_Folders').setAttribute('fileViewActive', 'true');
			// firefly_GetWindow().firefly_sidebarMode = true;
		} else {
			firefly_EraseContent(document.getElementById('firefly_treeFiles'));
			document.getElementById('firefly_treeFiles').style.display = 'none';
			document.getElementById('firefly_Folders').setAttribute('fileViewActive', 'false');
			// firefly_GetWindow().firefly_sidebarMode = false;
		}
	} catch (e) {
		firefly_Logger(e,'error');
	}
}


/*	NOTE: build transfers view
 *
*/
function firefly_rebuildTransfers() {
	try {
		var transfersTab = document.getElementById('firefly_Transfers');
		var transfers = firefly_GetWindow().firefly_copy;
		for (var i = 0;i< transfers.length;i++) {
			if (document.getElementById('transfer_' + i) != null) {
				document.getElementById('transfer_' + i).refresh();
			} else {
				if (transfers[i].transferDone) {
					continue;
				}
				var transfer = document.createElement('firefly_transfer');
				transfer.setAttribute('transNum', i);
				transfer.setAttribute('id', 'transfer_' + i);
				transfersTab.appendChild(transfer);
			}
		}
		setTimeout('firefly_rebuildTransfers()', 1000);	//	every 10 seconds rebuild transfer elements
	} catch (e) {
		firefly_Logger(e,'error');
	}
}


/*	NOTE: execute when sidebar opens
 *
*/
function firefly_treeLoad() {
	// alert('load');
	firefly_rebuildTree();
	firefly_rebuildTransfers();
}
window.addEventListener('load',firefly_treeLoad,false);


/*	NOTE: execute when sidebar closes
 *
*/
function firefly_treeUnload() {
	// alert('unload');
}
window.addEventListener('unload',firefly_treeUnload,false);

/*var fileChangeObserverStr = '';
fileChangeObserverStr += 'var observerService = Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces.nsIObserverService);';
fileChangeObserverStr += 'var observeFileChange = {';
fileChangeObserverStr += '	observe: function(subject,topic,data){';
fileChangeObserverStr += '		if (topic != "firefly_treeChange") {';
fileChangeObserverStr += '			return;';
fileChangeObserverStr += '		}';
fileChangeObserverStr += '		firefly_expandTreeByPath(firefly_GetWindow().firefly_expandTree[data]);';
fileChangeObserverStr += '	},';
fileChangeObserverStr += '	QueryInterface : function (aIID) {';
fileChangeObserverStr += '		if (aIID.equals(Components.interfaces.nsIObserver) ||';
fileChangeObserverStr += '			aIID.equals(Components.interfaces.nsISupports) ||';
fileChangeObserverStr += '			aIID.equals(Components.interfaces.nsISupportsWeakReference))';
fileChangeObserverStr += '			return this;';
fileChangeObserverStr += '		throw Components.results.NS_NOINTERFACE;';
fileChangeObserverStr += '	}';
fileChangeObserverStr += '};';
fileChangeObserverStr += 'observerService.addObserver(observeFileChange,"firefly_treeChange",true);';
window.addEventListener('load',fileChangeObserverStr,false);*/

var observerService = Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces.nsIObserverService);
var firefly_treeChange = {
	observe: function(subject,topic,data){
		if (topic != 'firefly_treeChange') {
			return;
		}
		firefly_expandTreeByPath(firefly_GetWindow().firefly_expandTree[data]);
	},
	QueryInterface : function (aIID) {
		if (aIID.equals(Components.interfaces.nsIObserver) ||
			aIID.equals(Components.interfaces.nsISupports) ||
			aIID.equals(Components.interfaces.nsISupportsWeakReference))
			return this;
		throw Components.results.NS_NOINTERFACE;
	}
};
observerService.addObserver(firefly_treeChange,'firefly_treeChange',true);
